void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->_TMP_ADD10_OUT,0,retain)
  __INIT_VAR(data__->_TMP_EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_SEL15_OUT,0,retain)
  __INIT_VAR(data__->_TMP_AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,_TMP_ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,_TMP_EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->_TMP_ADD10_OUT,)));
  __SET_VAR(data__->,_TMP_SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->_TMP_EQ13_OUT,),
    (UINT)__GET_VAR(data__->_TMP_ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->_TMP_SEL15_OUT,));
  __SET_VAR(data__->,_TMP_AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->_TMP_EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->_TMP_AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void INOUTCHK_init__(INOUTCHK *data__, BOOL retain) {
  __INIT_EXTERNAL(BOOL,IN0,data__->IN0,retain)
  __INIT_EXTERNAL(BOOL,IN1,data__->IN1,retain)
  __INIT_EXTERNAL(BOOL,IN2,data__->IN2,retain)
  __INIT_EXTERNAL(BOOL,IN3,data__->IN3,retain)
  __INIT_EXTERNAL(BOOL,IN4,data__->IN4,retain)
  __INIT_EXTERNAL(BOOL,IN5,data__->IN5,retain)
  __INIT_EXTERNAL(BOOL,IN6,data__->IN6,retain)
  __INIT_EXTERNAL(BOOL,IN7,data__->IN7,retain)
  __INIT_EXTERNAL(BOOL,IN8,data__->IN8,retain)
  __INIT_EXTERNAL(BOOL,IN9,data__->IN9,retain)
  __INIT_EXTERNAL(BOOL,IN10,data__->IN10,retain)
  __INIT_EXTERNAL(BOOL,IN11,data__->IN11,retain)
  __INIT_EXTERNAL(BOOL,IN12,data__->IN12,retain)
  __INIT_EXTERNAL(BOOL,IN13,data__->IN13,retain)
  __INIT_EXTERNAL(BOOL,IN14,data__->IN14,retain)
  __INIT_EXTERNAL(BOOL,IN15,data__->IN15,retain)
  __INIT_EXTERNAL(BOOL,OUT0,data__->OUT0,retain)
  __INIT_EXTERNAL(BOOL,OUT1,data__->OUT1,retain)
  __INIT_EXTERNAL(BOOL,OUT2,data__->OUT2,retain)
  __INIT_EXTERNAL(BOOL,OUT3,data__->OUT3,retain)
  __INIT_EXTERNAL(BOOL,OUT4,data__->OUT4,retain)
  __INIT_EXTERNAL(BOOL,OUT5,data__->OUT5,retain)
  __INIT_EXTERNAL(BOOL,OUT6,data__->OUT6,retain)
  __INIT_EXTERNAL(BOOL,OUT7,data__->OUT7,retain)
  __INIT_EXTERNAL(BOOL,OUT8,data__->OUT8,retain)
  __INIT_EXTERNAL(BOOL,OUT9,data__->OUT9,retain)
  __INIT_EXTERNAL(BOOL,OUT10,data__->OUT10,retain)
  __INIT_EXTERNAL(BOOL,OUT11,data__->OUT11,retain)
  __INIT_EXTERNAL(BOOL,OUT12,data__->OUT12,retain)
  __INIT_EXTERNAL(BOOL,OUT13,data__->OUT13,retain)
  __INIT_EXTERNAL(BOOL,OUT14,data__->OUT14,retain)
  __INIT_VAR(data__->TEMPRY,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void INOUTCHK_body__(INOUTCHK *data__) {
  // Initialise TEMP variables

  __SET_EXTERNAL(data__->,OUT0,,__GET_EXTERNAL(data__->IN0,));
  __SET_EXTERNAL(data__->,OUT1,,__GET_EXTERNAL(data__->IN1,));
  __SET_EXTERNAL(data__->,OUT2,,__GET_EXTERNAL(data__->IN2,));
  __SET_EXTERNAL(data__->,OUT3,,__GET_EXTERNAL(data__->IN3,));
  __SET_EXTERNAL(data__->,OUT4,,__GET_EXTERNAL(data__->IN4,));
  __SET_EXTERNAL(data__->,OUT5,,__GET_EXTERNAL(data__->IN5,));
  __SET_EXTERNAL(data__->,OUT6,,__GET_EXTERNAL(data__->IN6,));
  __SET_EXTERNAL(data__->,OUT7,,__GET_EXTERNAL(data__->IN7,));
  __SET_EXTERNAL(data__->,OUT8,,__GET_EXTERNAL(data__->IN8,));
  __SET_EXTERNAL(data__->,OUT9,,__GET_EXTERNAL(data__->IN9,));
  __SET_EXTERNAL(data__->,OUT10,,__GET_EXTERNAL(data__->IN10,));
  __SET_EXTERNAL(data__->,OUT11,,__GET_EXTERNAL(data__->IN11,));
  __SET_EXTERNAL(data__->,OUT12,,__GET_EXTERNAL(data__->IN12,));
  __SET_EXTERNAL(data__->,OUT13,,__GET_EXTERNAL(data__->IN13,));
  __SET_VAR(data__->,TEMPRY,,(__GET_EXTERNAL(data__->IN14,) || __GET_EXTERNAL(data__->IN15,)));
  __SET_EXTERNAL(data__->,OUT14,,__GET_VAR(data__->TEMPRY,));

  goto __end;

__end:
  return;
} // INOUTCHK_body__() 





void INBITINTERFACE_init__(INBITINTERFACE *data__, BOOL retain) {
  __INIT_VAR(data__->IN_0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_5,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_6,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_7,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_8,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_9,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_10,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_11,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_12,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_13,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_14,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_15,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN16,__BOOL_LITERAL(FALSE),retain)
  __INIT_EXTERNAL(BOOL,IN0,data__->IN0,retain)
  __INIT_EXTERNAL(BOOL,IN1,data__->IN1,retain)
  __INIT_EXTERNAL(BOOL,IN2,data__->IN2,retain)
  __INIT_EXTERNAL(BOOL,IN3,data__->IN3,retain)
  __INIT_EXTERNAL(BOOL,IN4,data__->IN4,retain)
  __INIT_EXTERNAL(BOOL,IN5,data__->IN5,retain)
  __INIT_EXTERNAL(BOOL,IN6,data__->IN6,retain)
  __INIT_EXTERNAL(BOOL,IN7,data__->IN7,retain)
  __INIT_EXTERNAL(BOOL,IN8,data__->IN8,retain)
  __INIT_EXTERNAL(BOOL,IN9,data__->IN9,retain)
  __INIT_EXTERNAL(BOOL,IN10,data__->IN10,retain)
  __INIT_EXTERNAL(BOOL,IN11,data__->IN11,retain)
  __INIT_EXTERNAL(BOOL,IN12,data__->IN12,retain)
  __INIT_EXTERNAL(BOOL,IN13,data__->IN13,retain)
  __INIT_EXTERNAL(BOOL,IN14,data__->IN14,retain)
  __INIT_EXTERNAL(BOOL,IN15,data__->IN15,retain)
}

// Code part
void INBITINTERFACE_body__(INBITINTERFACE *data__) {
  // Initialise TEMP variables

  __SET_EXTERNAL(data__->,IN0,,!(__GET_VAR(data__->IN_0,)));
  __SET_EXTERNAL(data__->,IN1,,!(__GET_VAR(data__->IN_1,)));
  __SET_EXTERNAL(data__->,IN2,,__GET_VAR(data__->IN_2,));
  __SET_EXTERNAL(data__->,IN3,,__GET_VAR(data__->IN_3,));
  __SET_EXTERNAL(data__->,IN4,,__GET_VAR(data__->IN_4,));
  __SET_EXTERNAL(data__->,IN5,,__GET_VAR(data__->IN_5,));
  __SET_EXTERNAL(data__->,IN6,,__GET_VAR(data__->IN_6,));
  __SET_EXTERNAL(data__->,IN7,,__GET_VAR(data__->IN_7,));
  __SET_EXTERNAL(data__->,IN8,,__GET_VAR(data__->IN_8,));
  __SET_EXTERNAL(data__->,IN9,,__GET_VAR(data__->IN_9,));
  __SET_EXTERNAL(data__->,IN10,,__GET_VAR(data__->IN_10,));
  __SET_EXTERNAL(data__->,IN11,,__GET_VAR(data__->IN_11,));
  __SET_EXTERNAL(data__->,IN12,,__GET_VAR(data__->IN_12,));
  __SET_EXTERNAL(data__->,IN13,,__GET_VAR(data__->IN_13,));
  __SET_EXTERNAL(data__->,IN14,,__GET_VAR(data__->IN_14,));
  __SET_EXTERNAL(data__->,IN15,,__GET_VAR(data__->IN_15,));

  goto __end;

__end:
  return;
} // INBITINTERFACE_body__() 





